##### Overview

- Download PMD 3.7
- What's new in PMD 3.7
- PMD in the news
- PMD-related products and books
- Best practices
- Future directions
- Similar projects
- Credits
- License
- What does 'PMD' mean?

##### Usage

- Installation
- Command line usage
- Ant task usage
- Maven plugin usage
- IDE plugin usage
- Suppressing warnings
- Finding duplicated code
- JSP support

##### Customizing PMD

- Compiling PMD
- How to write a rule
- Writing XPath rules
- How to make a rule set
- How it works

##### For example

- Run PMD on a Sourceforge project

##### Rule Sets

- Index
- Basic
- Braces
- Code Size
- Clone
- Controversial
- Coupling
- Design
- Finalizers
- Import Statements
- J2EE
- Javabeans
- JUnit Tests
- Logging (Java)
- Logging (Jakarta)
- Migrating
- Naming
- Optimizations
- Strict Exceptions
- Strings
- Sun Security
- Unused Code
- Java Server Pages
- Java Server Faces

##### Project Documentation

- About PMD
- Project Info
- Project Reports
- Development Process

## How to install PMD (and CPD)

### Windows

Prerequisites:

- JDK 1.3 or higher
- Winzip

Download the latest binary distribution - i.e., pmd-bin-x.xx.zip

Unzip it into any directory, i.e., c:\pmd\

### Unix

Prerequisites:

- JDK 1.3 or higher
- The Unix "zip" utility InfoZip

Download the latest binary distribution - i.e., pmd-bin-x.xx.zip

Unzip it into any directory:

                          [tom@hal tmp]$ unzip -q pmd-bin-3.7.zip
                          [tom@hal tmp]$ ls -l
                          total 4640
                          drwxrwxr-x    5 tom      tom          4096 Apr 17 16:38 pmd-3.7
                          -rw-rw-r--    1 tom      tom       4733312 Jun  9 15:44 pmd-bin-3.7.zip
                          [tom@hal tmp]$

Note that the PMD jar file contains the CPD utility as well.